#!/usr/bin/env python

"""
This test attempts to cause the recording of the usage of 'C' in the function
'f', alongside the expectation that 'D' might be used instead. A guard
stipulating constraints for all of 'f' cannot therefore be generated. Meanwhile,
the method 'E.h' should be eliminated.
"""

class C:
    def f(self):
        return 1

class D:
    def g(self):
        return 2

class E:
    def h(self):    # unused
        return 3

def f(c):
    if 1:
        if 1:
            x = c.f()
        return x
    return c.g()

c = C()
d = D()
e = E()
result1_1 = f(c)

# vim: tabstop=4 expandtab shiftwidth=4
